/*
 * Controlling LEDs using a 74HC595 shift register.
 *
 * The shift register grounds the LED when the bit is a 0.
 *
 */

#define DATA  4
#define LATCH 3
#define CLOCK 2

int row;

void setup()
{
  // put your setup code here, to run once:
  pinMode(LATCH, OUTPUT);
  pinMode(CLOCK, OUTPUT);
  pinMode(DATA, OUTPUT);

  pinMode(5, OUTPUT);
  pinMode(6, OUTPUT);
  pinMode(7, OUTPUT);
  pinMode(8, OUTPUT);
  pinMode(9, OUTPUT);
  pinMode(10, OUTPUT);
  pinMode(11, OUTPUT);

  row = 0;
}

void loop()
{
  // put your main code here, to run repeatedly:
  int i;
  int j;

  switch (row)
    {
    case 0:
      digitalWrite(11, LOW);
      digitalWrite(5, HIGH);
      break;
    case 1:
      digitalWrite(5, LOW);
      digitalWrite(6, HIGH);
      break;
    case 2:
      digitalWrite(6, LOW);
      digitalWrite(7, HIGH);
      break;
    case 3:
      digitalWrite(7, LOW);
      digitalWrite(8, HIGH);
      break;
    case 4:
      digitalWrite(8, LOW);
      digitalWrite(9, HIGH);
      break;
    case 5:
      digitalWrite(9, LOW);
      digitalWrite(10, HIGH);
      break;
    case 6:
      digitalWrite(10, LOW);
      digitalWrite(11, HIGH);
      break;
    }
  row++;
  if (row >= 7)
    row = 0;

  // Start with only the low bit set to 0.
  i = 0xFE;

  for (j = 0; j < 5; j++)
    {
    digitalWrite(LATCH, LOW);
    shiftOut(DATA, CLOCK, MSBFIRST, i);
    digitalWrite(LATCH, HIGH);
    delay(20);

    // Shift the 0 up one bit, filling in the low bit with a 1.
    i = (i << 1) | 1;
    }
}

